//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Delphi gp郂W[
//
//-----------------------------------------------------------------------------
//
//  2020N1108 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plEnumModuleForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  function EnumModules(AMemo: TMemo): Boolean;

var
  Form1: TForm1;

implementation

uses
  PsAPI;

{$R *.dfm}

{ TForm1 }

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.ScrollBars := ssBoth;
  Memo1.Font.Size  := 11;
  Memo1.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[\鎞̏
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate;
  EnumModules(Memo1);
  Memo1.Lines.EndUpdate;
end;

//-----------------------------------------------------------------------------
//  ݂̃vZXŎgpĂ郂W[
//
//  uses  Winapi.PsAPI Kv
//-----------------------------------------------------------------------------
function EnumModules(AMemo: TMemo): Boolean;
var
  LhProcess     : THandle;
  LSizeNeeded   : Cardinal;
  LhModuleArray : array of HMODULE;
  LhModule      : HMODULE;
  LModulePath   : string;
  LIndex        : Integer;
begin
  Result := False;

  // ݂̃vZX̃nh擾
  LhProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ,
                           False,
                           GetCurrentProcessId);
  if LhProcess = 0 then
    RaiseLastOSError;

  try
    // W[nh̒li[ɕKvȃ̃oCg擾
    LSizeNeeded := 0;
    EnumProcessModules(LhProcess, nil, 0, LSizeNeeded);
    if LSizeNeeded = 0 then Exit;

    // W[nh̒li[z̗vfݒ
    SetLength(LhModuleArray, LSizeNeeded div SizeOf(HMODULE));

    // W[nhl
    if EnumProcessModules(LhProcess,
                          PHMODULE(LhModuleArray),
                          LSizeNeeded,
                          LSizeNeeded) then begin

      // W[ꏊ (tpX) 擾ĕ\
      for LIndex := 0 to Length(LhModuleArray) - 1 do begin
        LhModule := LhModuleArray[LIndex];

        // g (̃vO EXE ) ͏O
        if LhModule <> HInstance then begin
          LModulePath := GetModuleName(LhModule);
          AMemo.Lines.Add(LModulePath);
        end;
      end;

      AMemo.Lines.Add('W[ : ' +  IntToStr(Length(LhModuleArray) - 1));
      if ModuleIsPackage then begin
        AMemo.Lines.Add('spbP[W');
      end else begin
        AMemo.Lines.Add('spbP[WȂ');
      end;

      Result := True;
    end;
  finally
    CloseHandle(LhProcess);
  end;
end;

end.

